import java.io.*;
import java.util.*;
import java.rmi.Naming;
import com.allaire.cfx.*;

public class JasperToPdf implements CustomTag {
    private String strJasperFile;
    private String strXmlFile;
    private String strSelectPath;
    private String strOutputFile;
    private String strExportType;

    public void processRequest(com.allaire.cfx.Request request, com.allaire.cfx.Response response) throws Exception {
        strJasperFile = request.getAttribute("JASPER");
        strXmlFile    = request.getAttribute("DATA");
        strSelectPath = request.getAttribute("XPATH");
        strOutputFile = request.getAttribute("OUT");
        strExportType = "pdf";
        
        System.out.println("JASPER: " + strJasperFile);
        System.out.println("DATA  : " + strXmlFile);
        System.out.println("XPATH : " + strSelectPath);
        System.out.println("OUT   : " + strOutputFile);
        
        // K{ڃ`FbNȗlZbg
        if (strJasperFile.length() == 0) {
            response.setVariable("result","NG");
            throw new Exception("JasperToPdf Error : Required JASPER attribute either empty or not specified.");
        }
        if (strXmlFile.length() == 0) {
            response.setVariable("result","NG");
            throw new Exception("JasperToPdf Error : Required DATA attribute either empty or not specified.");
        }
        if ( strOutputFile.length() == 0 ) {
            response.setVariable("result","NG");
            throw new Exception("JasperToPdf Error : Required OUT attribute either empty or not specified.");
        }
        
        // strJasperFile(JASPER)Ŏw肳ꂽt@C̑݃`FbN
        if (strJasperFile.length() != 0) {
            File wkFile = new File(strJasperFile);
            if (!wkFile.exists()) {
                response.setVariable("result","NG");
                throw new Exception("JasperToPdf Error : File not found. (JASPER: " +  strJasperFile + ")");
            }
            wkFile = null;
        }
        
        // strXmlFile(DATA)Ŏw肳ꂽt@C̑݃`FbN
        if (strXmlFile.length() != 0) {
            File wkFile = new File(strXmlFile);
            if (!wkFile.exists()) {
                response.setVariable("result","NG");
                throw new Exception("JasperToPdf Error : File not found. (DATA: " +  strXmlFile + ")");
            }
            wkFile = null;
        }
        
        try{
            // l[T[rXJasperIuWFNg̎QƂ擾
            JasperToPdfServer jasperToPdfServer = (JasperToPdfServer)Naming.lookup("rmi://localhost/JasperToPdfServer");
            
            System.out.println("Start JasperToPDFServer call.");
            
            // JasperToPdfServerdoPrintR[
            String ret = jasperToPdfServer.doPrint(strJasperFile, strXmlFile, strSelectPath, strExportType, strOutputFile);
            
            System.out.println("Complete JasperToPDFServer call. " + ret);
            response.setVariable("result","OK");
            
        } catch (Exception e) {
            response.setVariable("result","NG");
            throw new Exception("JasperToPdf Error : " + e.toString());
        }
    }
    
    // main (fobOsp)
    public static void main(String[] argv) {
        try {
            // initialize attributes
            Hashtable <String,Object>attributes = new Hashtable<String,Object>();
            attributes.put( "JASPER", "D:\\work\\jasperTEST\\JasperToPDF\\Web\\UserList.jasper" );
            attributes.put( "DATA",   "D:\\work\\jasperTEST\\JasperToPDF\\Web\\userslist.xml" );
            attributes.put( "XPATH",  "/REPORTS/ROWSET/ROW" );
            attributes.put( "OUT",    "D:\\work\\jasperTEST\\JasperToPDF\\Web\\UserList.pdf" );
            
            // create tag, process debug request, and print results
            JasperToPdf tag = new JasperToPdf();
            DebugRequest request = new DebugRequest(attributes);
            DebugResponse response = new DebugResponse();
            tag.processRequest(request, response);
            response.printResults();
        } catch( Throwable e ) {
            e.printStackTrace();
        }
    }
}
