import java.util.*;

import net.sf.jasperreports.engine.*;
import net.sf.jasperreports.engine.data.*;

import java.rmi.Naming;
import java.rmi.RMISecurityManager;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.rmi.server.UnicastRemoteObject;

public class JasperToPdfServerImpl extends UnicastRemoteObject implements JasperToPdfServer {
    private static JasperToPdfServer jasperToPdfServer;
    private static Runtime runtime;
    
    protected JasperToPdfServerImpl() throws RemoteException {
    }
    
    // RMINCAgĂ΂郁\bh
    @Override
    public String doPrint(String sourceFile, String xmlFile, String selectXPath
                    , String exportType, String outputFile) throws RemoteException {
        try {
            System.out.println("[쐬Jn.");
            System.out.println("JASPER:" + sourceFile);
            System.out.println("DATA  :" + xmlFile);
            System.out.println("XPATH :" + selectXPath);
            System.out.println("Type  :" + exportType);
            System.out.println("OUT   :" + outputFile);
            
            // XMLf[^\[X̒l̖ߍ
            JRXmlDataSource jrxmlds = new JRXmlDataSource(xmlFile, selectXPath);
            Map <String,Object>params = new HashMap<String,Object>();
            JasperPrint jrprint = JasperFillManager.fillReport(sourceFile, params, jrxmlds);
            
            // PDFt@Cɕϊ
            JasperExportManager.exportReportToPdfFile(jrprint, outputFile);
            System.out.println("Created PDF File: " + outputFile);
            
        } catch(Throwable e) {
            throw new RemoteException(e.toString());
        }
        return outputFile;
    }
    
    // Ns\bh(main)
    public static void main(String[] args) throws Exception {
        if(System.getSecurityManager() == null) {
            System.setSecurityManager(new RMISecurityManager());
        }
        
        try {
            LocateRegistry.createRegistry(Registry.REGISTRY_PORT);
            jasperToPdfServer = new JasperToPdfServerImpl();
            Naming.rebind("JasperToPdfServer", jasperToPdfServer);
            System.out.println("Start JasperToPDFServer Daemon.");
        } catch (Exception e) {
            throw new Exception("JasperToPdfServer Error : " + e.toString());
        }
    }
    
}
